Cantera 2.6.0

Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
MultiSpeciesThermo Class Reference
Models of Phases of Matter » Thermodynamic Properties » Species Reference-State Thermodynamic Properties

A species thermodynamic property manager for a phase. More...

`#include <MultiSpeciesThermo.h>`

## Public Member Functions
| MultiSpeciesThermo ()
| Constructor. More...
| MultiSpeciesThermo (const MultiSpeciesThermo &b)=delete
MultiSpeciesThermo & | operator= (const MultiSpeciesThermo &b)=delete
virtual void | install_STIT (size_t index, shared_ptr< SpeciesThermoInterpType > stit)
| Install a new species thermodynamic property parameterization for one species. More...
virtual void | modifySpecies (size_t index, shared_ptr< SpeciesThermoInterpType > spec)
| Modify the species thermodynamic property parameterization for a species. More...
virtual void | update_single (size_t k, double T, double *cp_R, double *h_RT, double *s_R) const
| Get reference-state properties for a single species. More...
virtual void | update (doublereal T, doublereal *cp_R, doublereal *h_RT, doublereal *s_R) const
| Compute the reference-state properties for all species. More...
virtual doublereal | minTemp (size_t k=npos) const
| Minimum temperature. More...
virtual doublereal | maxTemp (size_t k=npos) const
| Maximum temperature. More...
virtual doublereal | refPressure (size_t k=npos) const
| The reference-state pressure for species k. More...
virtual int | reportType (size_t index) const
| This utility function reports the type of parameterization used for the species with index number index. More...
virtual void | reportParams (size_t index, int &type, doublereal *const c, doublereal &minTemp, doublereal &maxTemp, doublereal &refPressure) const
| This utility function reports back the type of parameterization and all of the parameters for the species with index number index. More...
virtual doublereal | reportOneHf298 (const size_t k) const
| Report the 298 K Heat of Formation of the standard state of one species (J kmol-1) More...
virtual void | modifyOneHf298 (const size_t k, const doublereal Hf298New)
| Modify the value of the 298 K Heat of Formation of the standard state of one species in the phase (J kmol-1) More...
virtual void | resetHf298 (const size_t k)
| Restore the original heat of formation of one or more species. More...
bool | ready (size_t nSpecies)
| Check if data for all species (0 through nSpecies-1) has been installed. More...

## Protected Types
typedef std::pair< size_t, shared_ptr< SpeciesThermoInterpType > > | index_STIT
typedef std::map< int, std::vector< index_STIT > > | STIT_map
typedef std::map< int, vector_fp > | tpoly_map

## Protected Member Functions
void | markInstalled (size_t k)
| Mark species k as having its thermodynamic data installed. More...

## Protected Attributes
STIT_map | m_sp
| This is the main data structure, which contains the SpeciesThermoInterpType objects, sorted by the parameterization type. More...
tpoly_map | m_tpoly
| Temperature polynomials for each thermo parameterization. More...
std::map< size_t, std::pair< int, size_t > > | m_speciesLoc
| Map from species index to location within m_sp, such that `m_sp[m_speciesLoc[k].first][m_speciesLoc[k].second]` is the SpeciesThermoInterpType object for species `k`. More...
doublereal | m_tlow_max
| Maximum value of the lowest temperature. More...
doublereal | m_thigh_min
| Minimum value of the highest temperature. More...
doublereal | m_p0
| reference pressure (Pa) More...
std::vector< bool > | m_installed
| indicates if data for species has been installed More...

## Private Member Functions
SpeciesThermoInterpType * | provideSTIT (size_t k)
| Provide the SpeciesThermoInterpType object. More...
const SpeciesThermoInterpType * | provideSTIT (size_t k) const

## Detailed Description

A species thermodynamic property manager for a phase.

This is a general manager that can handle a wide variety of species thermodynamic polynomials for individual species and compute their nondimensional, reference-state thermodynamic properties (that is, as a function of temperature only).

The ThermoPhase object relies on MultiSpeciesThermo to calculate the thermodynamic properties of the reference state for all of the species in the phase, for a range of temperatures. Note, the pressure dependence of the species thermodynamic functions is not handled at this level. Species using the same parameterization are grouped together in order to minimize the operation count and achieve better efficiency.

The most important member function for the MultiSpeciesThermo class is the member function MultiSpeciesThermo::update(). The function calculates the values of Cp/R, H/RT, and S/R for all of the species at once at the specified temperature.

Usually, all of the species in a phase are installed into a MultiSpeciesThermo object. However, there is no requirement that a MultiSpeciesThermo object handles all of the species in a phase. The member function install_STIT() is called to install each species into the MultiSpeciesThermo object.

Definition at line 46 of file MultiSpeciesThermo.h.

## Member Typedef Documentation

## ◆ index_STIT

typedef std::pair<size_t, shared_ptr<SpeciesThermoInterpType> > index_STIT
| protected

Definition at line 204 of file MultiSpeciesThermo.h.

## ◆ STIT_map

typedef std::map<int, std::vector<index_STIT> > STIT_map
| protected

Definition at line 205 of file MultiSpeciesThermo.h.

## ◆ tpoly_map

typedef std::map<int, vector_fp> tpoly_map
| protected

Definition at line 206 of file MultiSpeciesThermo.h.

## Constructor & Destructor Documentation

## ◆ MultiSpeciesThermo()

MultiSpeciesThermo | ( |  | ) |

Constructor.

Definition at line 19 of file MultiSpeciesThermo.cpp.

## ◆ ~MultiSpeciesThermo()

virtual ~MultiSpeciesThermo | ( |  | ) |
| inline virtual

Definition at line 55 of file MultiSpeciesThermo.h.

## Member Function Documentation

## ◆ install_STIT()

void install_STIT | ( | size_t | index,
|  | shared_ptr< SpeciesThermoInterpType > | stit
| ) |  |
| virtual

Install a new species thermodynamic property parameterization for one species.

Parameters

  index | Index of the species being installed
  stit | Pointer to the SpeciesThermoInterpType object This will set up the thermo for one species

Definition at line 26 of file MultiSpeciesThermo.cpp.

References AssertThrowMsg, and MultiSpeciesThermo::m_speciesLoc.

Referenced by ThermoPhase::addSpecies(), and VPStandardStateTP::addSpecies().

## ◆ modifySpecies()

void modifySpecies | ( | size_t | index,
|  | shared_ptr< SpeciesThermoInterpType > | spec
| ) |  |
| virtual

Modify the species thermodynamic property parameterization for a species.

Parameters

  index | Index of the species being installed
  spec | Pointer to the SpeciesThermoInterpType object

Definition at line 49 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_speciesLoc.

Referenced by ThermoPhase::modifySpecies().

## ◆ update_single()

void update_single | ( | size_t | k,
|  | double | T,
|  | double * | cp_R,
|  | double * | h_RT,
|  | double * | s_R
| ) |  | const
| virtual

Get reference-state properties for a single species.

Parameters

  k | species index
  T | Temperature (Kelvin)
  cp_R | Dimensionless heat capacity
  h_RT | Dimensionless enthalpy
  s_R | Dimensionless entropy

Definition at line 81 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::provideSTIT(), and SpeciesThermoInterpType::updatePropertiesTemp().

Referenced by PlasmaPhase::updateThermo().

## ◆ update()

void update | ( | doublereal | T,
|  | doublereal * | cp_R,
|  | doublereal * | h_RT,
|  | doublereal * | s_R
| ) |  | const
| virtual

Compute the reference-state properties for all species.

Given temperature T in K, this method updates the values of the non- dimensional heat capacity at constant pressure, enthalpy, and entropy, at the reference pressure, Pref of each of the standard states.

Parameters

  T | Temperature (Kelvin)
  cp_R | Vector of Dimensionless heat capacities. (length m_kk).
  h_RT | Vector of Dimensionless enthalpies. (length m_kk).
  s_R | Vector of Dimensionless entropies. (length m_kk).

Definition at line 90 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_sp, and MultiSpeciesThermo::m_tpoly.

Referenced by MixtureFugacityTP::_updateReferenceStateThermo(), BinarySolutionTabulatedThermo::_updateThermo(), IdealSolidSolnPhase::_updateThermo(), LatticePhase::_updateThermo(), SingleSpeciesTP::_updateThermo(), SurfPhase::_updateThermo(), and IdealGasPhase::updateThermo().

## ◆ minTemp()

doublereal minTemp | ( | size_t | k = `npos` | ) | const
| virtual

Minimum temperature.

If no argument is supplied, this method returns the minimum temperature for which all parameterizations are valid. If an integer index k is supplied, then the value returned is the minimum temperature for species k in the phase.

Parameters

  k | Species index

Definition at line 129 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_tlow_max, SpeciesThermoInterpType::minTemp(), Cantera::npos, and MultiSpeciesThermo::provideSTIT().

Referenced by ThermoPhase::minTemp().

## ◆ maxTemp()

doublereal maxTemp | ( | size_t | k = `npos` | ) | const
| virtual

Maximum temperature.

If no argument is supplied, this method returns the maximum temperature for which all parameterizations are valid. If an integer index k is supplied, then the value returned is the maximum temperature for parameterization k.

Parameters

  k | Species Index

Definition at line 140 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_thigh_min, SpeciesThermoInterpType::maxTemp(), Cantera::npos, and MultiSpeciesThermo::provideSTIT().

Referenced by ThermoPhase::maxTemp().

## ◆ refPressure()

doublereal refPressure | ( | size_t | k = `npos` | ) | const
| virtual

The reference-state pressure for species k.

Returns the reference state pressure in Pascals for species k. If k is left out of the argument list, it returns the reference state pressure for the first species.

Parameters

  k | Species Index

Definition at line 151 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_p0, Cantera::npos, MultiSpeciesThermo::provideSTIT(), and SpeciesThermoInterpType::refPressure().

Referenced by ThermoPhase::refPressure().

## ◆ reportType()

int reportType | ( | size_t | index | ) | const
| virtual

This utility function reports the type of parameterization used for the species with index number index.

Parameters

  index | Species index

Definition at line 106 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::provideSTIT(), and SpeciesThermoInterpType::reportType().

## ◆ reportParams()

void reportParams | ( | size_t | index,
|  | int & | type,
|  | doublereal *const | c,
|  | doublereal & | minTemp,
|  | doublereal & | maxTemp,
|  | doublereal & | refPressure
| ) |  | const
| virtual

This utility function reports back the type of parameterization and all of the parameters for the species with index number index.

Parameters

  index | Species index
  type | Integer type of the standard type
  c | Vector of coefficients used to set the parameters for the standard state.
  minTemp | output - Minimum temperature
  maxTemp | output - Maximum temperature
  refPressure | output - reference pressure (Pa).

Definition at line 115 of file MultiSpeciesThermo.cpp.

## ◆ reportOneHf298()

doublereal reportOneHf298 | ( | const size_t | k | ) | const
| virtual

Report the 298 K Heat of Formation of the standard state of one species (J kmol-1)

The 298K Heat of Formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  k | species index

Returns
  the current value of the Heat of Formation at 298K and 1 bar

Definition at line 182 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::provideSTIT(), and SpeciesThermoInterpType::reportHf298().

Referenced by ThermoPhase::Hf298SS().

## ◆ modifyOneHf298()

void modifyOneHf298 | ( | const size_t | k,
|  | const doublereal | Hf298New
| ) |  |
| virtual

Modify the value of the 298 K Heat of Formation of the standard state of one species in the phase (J kmol-1)

The 298K heat of formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  k | Index of the species
  Hf298New | Specify the new value of the Heat of Formation at 298K and 1 bar. units = J/kmol.

Definition at line 192 of file MultiSpeciesThermo.cpp.

References SpeciesThermoInterpType::modifyOneHf298(), and MultiSpeciesThermo::provideSTIT().

Referenced by LatticeSolidPhase::modifyOneHf298SS(), and ThermoPhase::modifyOneHf298SS().

## ◆ resetHf298()

void resetHf298 | ( | const size_t | k | ) |
| virtual

Restore the original heat of formation of one or more species.

Resets changes made by modifyOneHf298(). If the species index is not specified, the heats of formation for all species are restored.

Definition at line 200 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::provideSTIT(), and SpeciesThermoInterpType::resetHf298().

Referenced by ThermoPhase::resetHf298().

## ◆ ready()

bool ready | ( | size_t | nSpecies | ) |

Check if data for all species (0 through nSpecies-1) has been installed.

Definition at line 208 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_installed.

Referenced by ThermoPhase::initThermo().

## ◆ provideSTIT() [1/2]

SpeciesThermoInterpType * provideSTIT | ( | size_t | k | ) |
| private

Provide the SpeciesThermoInterpType object.

Parameters

  k | species index

Returns
  pointer to the SpeciesThermoInterpType object.

Definition at line 162 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_sp, and MultiSpeciesThermo::m_speciesLoc.

Referenced by MultiSpeciesThermo::maxTemp(), MultiSpeciesThermo::minTemp(), MultiSpeciesThermo::modifyOneHf298(), MultiSpeciesThermo::refPressure(), MultiSpeciesThermo::reportOneHf298(), MultiSpeciesThermo::reportType(), MultiSpeciesThermo::resetHf298(), and MultiSpeciesThermo::update_single().

## ◆ provideSTIT() [2/2]

const SpeciesThermoInterpType * provideSTIT | ( | size_t | k | ) | const
| private

Definition at line 172 of file MultiSpeciesThermo.cpp.

## ◆ markInstalled()

void markInstalled | ( | size_t | k | ) |
| protected

Mark species k as having its thermodynamic data installed.

Definition at line 220 of file MultiSpeciesThermo.cpp.

References MultiSpeciesThermo::m_installed.

## Member Data Documentation

## ◆ m_sp

STIT_map m_sp
| protected

This is the main data structure, which contains the SpeciesThermoInterpType objects, sorted by the parameterization type.

`m_sp[i]` is the vector of [species index, STIT] pairs which use parameterization `i`.

Definition at line 212 of file MultiSpeciesThermo.h.

Referenced by MultiSpeciesThermo::provideSTIT(), and MultiSpeciesThermo::update().

## ◆ m_tpoly

tpoly_map m_tpoly
| mutable protected

Temperature polynomials for each thermo parameterization.

Definition at line 215 of file MultiSpeciesThermo.h.

Referenced by MultiSpeciesThermo::update().

## ◆ m_speciesLoc

std::map<size_t, std::pair<int, size_t> > m_speciesLoc
| protected

Map from species index to location within m_sp, such that `m_sp[m_speciesLoc[k].first][m_speciesLoc[k].second]` is the SpeciesThermoInterpType object for species `k`.

Definition at line 220 of file MultiSpeciesThermo.h.

Referenced by MultiSpeciesThermo::install_STIT(), MultiSpeciesThermo::modifySpecies(), and MultiSpeciesThermo::provideSTIT().

## ◆ m_tlow_max

doublereal m_tlow_max
| protected

Maximum value of the lowest temperature.

Definition at line 223 of file MultiSpeciesThermo.h.

Referenced by MultiSpeciesThermo::minTemp().

## ◆ m_thigh_min

doublereal m_thigh_min
| protected

Minimum value of the highest temperature.

Definition at line 226 of file MultiSpeciesThermo.h.

Referenced by MultiSpeciesThermo::maxTemp().

## ◆ m_p0

doublereal m_p0
| protected

reference pressure (Pa)

Definition at line 229 of file MultiSpeciesThermo.h.

Referenced by MultiSpeciesThermo::refPressure().

## ◆ m_installed

std::vector<bool> m_installed
| protected

indicates if data for species has been installed

Definition at line 232 of file MultiSpeciesThermo.h.

Referenced by MultiSpeciesThermo::markInstalled(), and MultiSpeciesThermo::ready().

The documentation for this class was generated from the following files:

- MultiSpeciesThermo.h
- MultiSpeciesThermo.cpp